chrome.runtime.onInstalled.addListener(function (e) {
  "install" == e.reason || e.reason,
    chrome.tabs.query({ url: "https://web.whatsapp.com/*" }, function (e) {
      e.length > 0
        ? chrome.tabs.reload(e[0].id)
        : chrome.tabs.create({ url: "https://web.whatsapp.com", active: !0 });
    });
}),
  chrome.action.onClicked.addListener(function (e) {
    chrome.tabs.query(
      { url: "https://web.whatsapp.com/*", currentWindow: !0 },
      function (e) {
        e.length > 0
          ? chrome.tabs.update(e[0].id, { highlighted: !0, selected: !0 })
          : chrome.tabs.create({ url: "https://web.whatsapp.com" });
      }
    );
  }),
  chrome.runtime.onMessage.addListener(function (e, t, n) {
    return (
      "SET_UNINSTALL_URL" == e.subject
        ? (chrome.runtime.setUninstallURL(e.url), n({}))
        : "SEND_RICH_NOTIFICATION" == e.subject &&
          (chrome.notifications.create(
            `${e.notificationId}$@$notification${Date.now()}`,
            {
              type: "basic",
              iconUrl: "icon-128.png",
              title: e.title,
              message: e.message,
            }
          ),
          n({})),
      !0
    );
  }),
  chrome.notifications.onClicked.addListener(function (e) {
    chrome.tabs.query({ url: "https://web.whatsapp.com/*" }, function (t) {
      t.length > 0
        ? (chrome.tabs.update(t[0].id, { selected: !0 }),
          chrome.tabs.sendMessage(
            t[0].id,
            { subject: "ON_CLICK_RICH_NOTIFICATION", notifId: e },
            function () {}
          ))
        : chrome.tabs.create({ url: "https://web.whatsapp.com", active: !0 });
    });
  }),
  // Listen for messages from the content script
chrome.runtime.onMessage.addListener(function(message, sender, sendResponse) {
  console.log("run")
  if (message.action === "saveLogo") {
    saveLogoToExtensionFolder(message.imageData)
      .then(() => sendResponse({ success: true }))
      .catch((error) => sendResponse({ success: false, error: error.message }));
    return true; // Indicates that the response will be sent asynchronously
  }
}),

async function saveLogoToExtensionFolder(imageData) {
  try {
    // Get the root directory of the Chrome extension
    const rootDirectory = await new Promise((resolve, reject) => {
      chrome.runtime.getPackageDirectoryEntry(resolve, reject);
    });

    // Create or open the 'images' directory inside the root directory
    const imagesDirectory = await rootDirectory.getDirectory('images', { create: true });

    // Create a new FileHandle for the logo image
    const logoFileHandle = await imagesDirectory.getFileHandle('logo.png', { create: true });

    // Write the logo image data to the file
    const writable = await logoFileHandle.createWritable();
    await writable.write(imageData);
    await writable.close();
  } catch (error) {
    console.error('Error saving logo image to the extension folder:', error);
    throw error;
  }
}


  